                                                                                 #REM
			Test Calibrate/reProgramme Meter Inputs
			   on Charge Controller v1 & 2 & 3
			  Ver 1		23rd February 2008
#ENDREM


	#picaxe 28X					;commands Programming Editor to use its 28X settings
	;#picaxe 28X1				;commands Programming Editor to use its 28X1 settings

Main:
	DO
	readadc10 0,w0		; Volt's ADC signal

	readadc 1, b2		; read in from +&- 100 Amp sorce No1's ADC signal	(Battery Amps)
	readadc 3, b4		; read in from +&-  50 Amp sorce No2's ADC signal	(Generator Amps)(one input version)
	readadc10 3, w6		; read in from +&- 100 Amp sorce No3's ADC signal	(Available Amps)

	sertxd (cr,lf,".  V_",#w0,".  .  .  No1_",#b2,".  .  .  No2_",#b4,".  .  .  No3_",#w6)	; send data to PC for Prog' Editor's Terminal logging


;		*** Calc reading for Display ***

	b8 = w0 -100 		; VOLTS

	b9 = b2-22			;min 0 max 256	; reads 128 to 28 for -100amps and 128 to 228  for +100amps
	b10 = b4-27			;min 0 max 256	; reads 128 to 28 for -100amps and 128 to 228  for +100amps
	b6 = w6/5-101 min 0	; actually,   b6 = w6-508/5 min 0    (but it underflows)

	sertxd (cr,lf,".  V_",#b8,".  .  .  No1_",#b9,".  .  .  No2_",#b10,".  .  .  No3_",#b6)


;		*** Calc reading for Logging ***

	b0 = w0 -100 		; VOLTS		; + 100 then /10 for correct value to one decimal place

	;b1 = b2-22	min 0 max 256			; suits graphing, if 0 is offset 100
	if b2 > 122 then gosub pos_bat 		; suits logging of + or - values
	if b2 = 122 then gosub zero_bat		; suits logging of + or - values
	if b2 < 122 then gosub neg_bat		; suits logging of + or - values

	;b3 = b4-27 min 0 max 256			; suits graphing, if 0 is offset 100
	if b4 > 127 then gosub pos_avl
	if b4 = 127 then gosub zero_avl
	if b4 < 127 then gosub neg_avl

	if w6 > 508 then gosub pos 			; suits logging of + or - values, /10 to give one decimal place
	if w6 = 508 then gosub zero			; suits logging of + or - values, /10 to give one decimal place
	if w6 < 508 then gosub neg			; suits logging of + or - values, /10 to give one decimal place

		
;		*** View readings on Terminal ***

	sertxd (cr,lf,".  V_",#b0,".  .  .  No1_ ",b5,#b1,".  .  .  No2_",b6,#b3,".  .  .  No3_ ",b2,#w5,cr,lf)

	pause 4000
	LOOP

pos_bat:
	b1=b2-122
	b5="+"
	return
pos_avl:
	b3=b4-127
	b6="+"
	return
pos:
	w5=w6-508*2
	b2="+"
	return
zero_bat:
	b1=0
	b5=" "
	return
zero_avl:
	b3=0
	b6=" "
	return
zero:
	w5=0
	b2=" "
	return
neg_bat:
	b1=122-b2
	b5="-"
	return
neg_avl:
	b3=127-b4
	b6="-"
	return
neg:
	w5=508-w6*2
	b2="-"
	return


END

















